<Query Kind="Program">
  <Reference>&lt;RuntimeDirectory&gt;\System.XML.dll</Reference>
  <Namespace>System.Xml.Serialization</Namespace>
</Query>

static void Main()
{
	string filename = @"C:\Users\rk\Documents\LINQPad Queries\TVGuide\23112014.xml";
	var doc = XDocument.Load(filename);
	var elements = doc.Elements();
	//elements.Dump();
	var channels = doc.Descendants().Where(e=>e.Name=="ch");
//	channels.Dump();
	var channelNames = channels.Select (c =>c.Attribute("v").Value);
	//channelNames.Dump();
	
	
	string xml = File.ReadAllText(filename);
    var tvguide = xml.ParseXML<tvguide>();
	tvguide.Dump();
//	Debugger.Launch();
}

// Define other methods and classes here


/// <remarks/>
[System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true)]
[System.Xml.Serialization.XmlRootAttribute(Namespace="", IsNullable=false)]
public partial class tvguide {
    
    private tvguideCity cityField;
    
    /// <remarks/>
    public tvguideCity city {
        get {
            return this.cityField;
        }
        set {
            this.cityField = value;
        }
    }
}

/// <remarks/>
[System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true)]
public partial class tvguideCity {
    
    private tvguideCityCH[] chField;
    
    private string vField;
    
    private uint dField;
    
    /// <remarks/>
    [System.Xml.Serialization.XmlElementAttribute("ch")]
    public tvguideCityCH[] ch {
        get {
            return this.chField;
        }
        set {
            this.chField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string v {
        get {
            return this.vField;
        }
        set {
            this.vField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public uint d {
        get {
            return this.dField;
        }
        set {
            this.dField = value;
        }
    }
}

/// <remarks/>
[System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true)]
public partial class tvguideCityCH {
    
    private tvguideCityCHT[] tField;
    
    private string vField;
    
    /// <remarks/>
    [System.Xml.Serialization.XmlElementAttribute("t")]
    public tvguideCityCHT[] t {
        get {
            return this.tField;
        }
        set {
            this.tField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string v {
        get {
            return this.vField;
        }
        set {
            this.vField = value;
        }
    }
}

/// <remarks/>
[System.Xml.Serialization.XmlTypeAttribute(AnonymousType=true)]
public partial class tvguideCityCHT {
    
    private string dField;
    
    private string lField;
    
    private string rField;
    
    private string cField;
    
    private string vField;
    
    private string eField;
    
    private byte pField;
    
    private byte oField;
    
    private bool oFieldSpecified;
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string d {
        get {
            return this.dField;
        }
        set {
            this.dField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string l {
        get {
            return this.lField;
        }
        set {
            this.lField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string r {
        get {
            return this.rField;
        }
        set {
            this.rField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string c {
        get {
            return this.cField;
        }
        set {
            this.cField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string v {
        get {
            return this.vField;
        }
        set {
            this.vField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public string e {
        get {
            return this.eField;
        }
        set {
            this.eField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public byte p {
        get {
            return this.pField;
        }
        set {
            this.pField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlAttributeAttribute()]
    public byte o {
        get {
            return this.oField;
        }
        set {
            this.oField = value;
        }
    }
    
    /// <remarks/>
    [System.Xml.Serialization.XmlIgnoreAttribute()]
    public bool oSpecified {
        get {
            return this.oFieldSpecified;
        }
        set {
            this.oFieldSpecified = value;
        }
    }
}

public static class Extensions {
	public static Stream ToStream(this string @this)
        {
            var stream = new MemoryStream();
            var writer = new StreamWriter(stream);
            writer.Write(@this);
            writer.Flush();
            stream.Position = 0;
            return stream;
        }


        public static T ParseXML<T>(this string @this) where T : class
        {
            var reader = XmlReader.Create(@this.Trim().ToStream(), new XmlReaderSettings() { 
//				ConformanceLevel = ConformanceLevel.Document 
				ConformanceLevel = ConformanceLevel.Fragment
			});
            return new XmlSerializer(typeof(T)).Deserialize(reader) as T;
        }
}